Skip to content

Stripe: Create an invoice item

Stripe invoiceitems.postInvoiceitems: arguments, response, policy and SDK examples.

← Invoiceitems operations · Get started

Operation stripe.postinvoiceitems

Provider route: POST /v1/invoiceitems. Alter supplies the connection’s credentials and routing.

Install @alter-ai/sdk @alter-ai/stripe with npm, or alter-sdk-stripe with pip. Supply your connected customer’s grant ID and the arguments described below.

import { App } from "@alter-ai/sdk";
import { StripeIntegration } from "@alter-ai/stripe";
async function execute(input: Parameters<StripeIntegration["invoiceitems"]["postInvoiceitems"]>[0]) {
const app = new App({ apiKey: process.env.ALTER_API_KEY! });
try {
const provider = new StripeIntegration(app, { grantId: process.env.PROVIDER_GRANT_ID! });
const call = await provider.invoiceitems.postInvoiceitems(input);
const result = await call.wait();
return result.bodyJson();
} finally {
await app.close();
}
}
import os
from alter_sdk import App
from alter_sdk_stripe import StripeIntegration
async def execute(arguments):
async with App(api_key=os.environ["ALTER_API_KEY"]) as app:
provider = StripeIntegration(app, {"grant_id": os.environ["PROVIDER_GRANT_ID"]})
call = await provider.invoiceitems.post_invoiceitems(arguments)
result = await call.wait()
return result.body_json()
FieldTypePresenceDescription and constraints
$objectRootAdditional keys: not allowed
headersobjectOptionalAdditional keys: not allowed
headers.Idempotency-KeystringOptionalMinimum length: 1
Maximum length: 255
bodyobjectOptionalAdditional keys: not allowed
body.amountintegerOptionalThe integer amount in cents (or local equivalent) of the charge to be applied to the upcoming invoice. Passing in a negative `amount` will reduce the `amount_due` on the invoice.
body.currencystringOptionalThree-letter [ISO currency code](https://www.iso.org/iso-4217-currency-codes.html), in lowercase. Must be a [supported currency](https://stripe.com/docs/currencies).
Format: currency
body.customerstringOptionalThe ID of the customer to bill for this invoice item.
Maximum length: 5000
body.customer_accountstringOptionalThe ID of the account representing the customer to bill for this invoice item.
Maximum length: 5000
body.descriptionstringOptionalAn arbitrary string which you can attach to the invoice item. The description is displayed in the invoice for easy tracking.
Maximum length: 5000
body.discountablebooleanOptionalControls whether discounts apply to this invoice item. Defaults to false for prorations or negative invoice items, and true for all other invoice items.
body.discountsJSONOptionalThe coupons and promotion codes to redeem into discounts for the invoice item or invoice line item.
body.discounts (anyOf 1)arrayAlternative
body.discounts (anyOf 1)[]objectEach item
body.discounts (anyOf 1)[].couponstringOptionalMaximum length: 5000
body.discounts (anyOf 1)[].discountstringOptionalMaximum length: 5000
body.discounts (anyOf 1)[].promotion_codestringOptionalMaximum length: 5000
body.discounts (anyOf 2)stringAlternativeOne of:
body.expandarrayOptionalSpecifies which fields in the response should be expanded.
body.expand[]stringEach itemMaximum length: 5000
body.invoicestringOptionalThe ID of an existing invoice to add this invoice item to. For subscription invoices, when left blank, the invoice item will be added to the next upcoming scheduled invoice. For standalone invoices, the invoice item won’t be automatically added unless you pass `pending_invoice_item_behavior: ‘include’` when creating the invoice. This is useful when adding invoice items in response to an invoice.created webhook. You can only add invoice items to draft invoices and there is a maximum of 250 items per invoice.
Maximum length: 5000
body.metadataJSONOptionalSet of [key-value pairs](https://docs.stripe.com/api/metadata) that you can attach to an object. This can be useful for storing additional information about the object in a structured format. Individual keys can be unset by posting an empty value to them. All keys can be unset by posting an empty value to `metadata`.
body.metadata (anyOf 1)objectAlternativeAdditional keys: see wildcard field
body.metadata (anyOf 1).*stringAdditional keys
body.metadata (anyOf 2)stringAlternativeOne of:
body.periodModelOptionalExpand Create an invoice item — request body — body period
body.price_dataobjectOptionalData used to generate a new [Price](https://docs.stripe.com/api/prices) object inline.
body.price_data.currencystringRequired within parentFormat: currency
body.price_data.productstringRequired within parentMaximum length: 5000
body.price_data.tax_behaviorstringOptionalOne of: exclusive, inclusive, unspecified
body.price_data.unit_amountintegerOptional
body.price_data.unit_amount_decimalstringOptionalFormat: decimal
body.pricingobjectOptionalThe pricing information for the invoice item.
body.pricing.pricestringOptionalMaximum length: 5000
body.quantityintegerOptionalNon-negative integer. The quantity of units for the invoice item. Use `quantity_decimal` instead to provide decimal precision. This field will be deprecated in favor of `quantity_decimal` in a future version.
body.quantity_decimalstringOptionalNon-negative decimal with at most 12 decimal places. The quantity of units for the invoice item.
Format: decimal
body.subscriptionstringOptionalThe ID of a subscription to add this invoice item to. When left blank, the invoice item is added to the next upcoming scheduled invoice. When set, scheduled invoices for subscriptions other than the specified subscription will ignore the invoice item. Use this when you want to express that an invoice item has been accrued within the context of a particular subscription.
Maximum length: 5000
body.tax_behaviorstringOptionalOnly required if a [default tax behavior](https://docs.stripe.com/tax/products-prices-tax-categories-tax-behavior#setting-a-default-tax-behavior-(recommended)) was not provided in the Stripe Tax settings. Specifies whether the price is considered inclusive of taxes or exclusive of taxes. One of `inclusive`, `exclusive`, or `unspecified`. Once specified as either `inclusive` or `exclusive`, it cannot be changed.
One of: exclusive, inclusive, unspecified
body.tax_codeJSONOptionalA [tax code](https://docs.stripe.com/tax/tax-categories) ID.
body.tax_code (anyOf 1)stringAlternative
body.tax_code (anyOf 2)stringAlternativeOne of:
body.tax_ratesarrayOptionalThe tax rates which apply to the invoice item. When set, the `default_tax_rates` on the invoice do not apply to this invoice item.
body.tax_rates[]stringEach itemMaximum length: 5000
body.unit_amount_decimalstringOptionalThe decimal unit amount in cents (or local equivalent) of the charge to be applied to the upcoming invoice. This `unit_amount_decimal` will be multiplied by the quantity to get the full amount. Passing in a negative `unit_amount_decimal` will reduce the `amount_due` on the invoice. Accepts at most 12 decimal places.
Format: decimal

Referenced models: Create an invoice item — request body — body period

Response media type: application/json. The table describes the pinned successful response. Referenced models link to their complete fields.

FieldTypePresenceDescription and constraints
$ModelRootExpand Create an invoice item — response body

Referenced models: Create an invoice item — response body

715 more schemas are linked from the tables above, on the schema pages.

Create an invoice item — response body
FieldTypePresenceDescription and constraints
$objectRootInvoice Items represent the component lines of an [invoice](https://docs.stripe.com/api/invoices). When you create an invoice item with an `invoice` field, it is attached to the specified invoice and included as [an invoice line item](https://docs.stripe.com/api/invoices/line_item) within [invoice.lines](https://docs.stripe.com/api/invoices/object#invoice_object-lines).

Invoice Items can be created before you are ready to actually send the invoice. This can be particularly useful when combined
with a [subscription](https://docs.stripe.com/api/subscriptions). Sometimes you want to add a charge or credit to a customer, but actually charge
or credit the customer's card only at the end of a regular billing cycle. This is useful for combining several charges
(to minimize per-transaction fees), or for having Stripe tabulate your usage-based billing totals.

Related guides: [Integrate with the Invoicing API](https://docs.stripe.com/invoicing/integration), [Subscription Invoices](https://docs.stripe.com/billing/invoices/subscription#adding-upcoming-invoice-items).
amountJSONRequired within parent
amount (anyOf 1)integerAlternativeAmount (in the `currency` specified) of the invoice item. This should always be equal to `unit_amount * quantity`.
amount (anyOf 2)stringAlternativePattern: ^-?[0-9]+(?:\.[0-9]+)?(?:[eE][+-]?[0-9]+)?$
currencystringRequired within parentThree-letter [ISO currency code](https://www.iso.org/iso-4217-currency-codes.html), in lowercase. Must be a [supported currency](https://stripe.com/docs/currencies).
Format: currency
customerJSONRequired within parentThe ID of the customer to bill for this invoice item.
customer (anyOf 1)stringAlternativeMaximum length: 5000
customer (anyOf 2)ModelAlternativeExpand Create a customer — response body
customer (anyOf 3)ModelAlternativeExpand Delete a customer — response body
customer_accountJSONOptional
customer_account (anyOf 1)stringAlternativeThe ID of the account to bill for this invoice item.
Maximum length: 5000
customer_account (anyOf 2)nullAlternative
dateJSONRequired within parent
date (anyOf 1)integerAlternativeTime at which the object was created. Measured in seconds since the Unix epoch.
Format: unix-time
date (anyOf 2)stringAlternativePattern: ^-?[0-9]+(?:\.[0-9]+)?(?:[eE][+-]?[0-9]+)?$
descriptionJSONOptional
description (anyOf 1)stringAlternativeAn arbitrary string attached to the object. Often useful for displaying to users.
Maximum length: 5000
description (anyOf 2)nullAlternative
discountablebooleanRequired within parentIf true, discounts will apply to this invoice item. Always false for prorations.
discountsJSONOptional
discounts (anyOf 1)arrayAlternativeThe discounts which apply to the invoice item. Item discounts are applied before invoice discounts. Use `expand[]=discounts` to expand each discount.
discounts (anyOf 1)[]JSONEach item
discounts (anyOf 1)[] (anyOf 1)stringAlternativeMaximum length: 5000
discounts (anyOf 1)[] (anyOf 2)ModelAlternativeExpand Get Customers Customer Discount — response body
discounts (anyOf 2)nullAlternative
frozen_fieldsarrayOptionalArray of field names that can't be modified. Attempting to update a frozen field returns an error.
frozen_fields[]stringEach itemKnown values: discounts, pricing, quantity
idstringRequired within parentUnique identifier for the object.
Maximum length: 5000
invoiceJSONOptional
invoice (anyOf 1)JSONAlternativeThe ID of the invoice this invoice item belongs to.
invoice (anyOf 1) (anyOf 1)stringAlternativeMaximum length: 5000
invoice (anyOf 1) (anyOf 2)ModelAlternativeExpand Pay an invoice — response body
invoice (anyOf 2)nullAlternative
invoicing_rulesarrayOptionalThe rules that control when this invoice item is eligible for invoicing. All rules must be satisfied for the item to be invoiced.
invoicing_rules[]ModelEach itemExpand Create an invoice item — response body — invoicing rules item
livemodebooleanRequired within parentIf the object exists in live mode, the value is `true`. If the object exists in test mode, the value is `false`.
metadataJSONOptional
metadata (anyOf 1)objectAlternativeSet of [key-value pairs](https://docs.stripe.com/api/metadata) that you can attach to an object. This can be useful for storing additional information about the object in a structured format.
Additional keys: see wildcard field
metadata (anyOf 1).*stringAdditional keysMaximum length: 500
metadata (anyOf 2)nullAlternative
net_amountJSONOptional
net_amount (anyOf 1)integerAlternativeThe amount after discounts, but before credits and taxes. This field is `null` for `discountable=true` items.
net_amount (anyOf 2)stringAlternativePattern: ^-?[0-9]+(?:\.[0-9]+)?(?:[eE][+-]?[0-9]+)?$
objectstringRequired within parentString representing the object's type. Objects of the same type share the same value.
Known values: invoiceitem
parentJSONOptional
parent (anyOf 1)JSONAlternativeThe parent that generated this invoice item.
parent (anyOf 1) (anyOf 1)ModelAlternativeExpand Create an invoice item — response body — parent / The parent that generated this invoice item / type: subscription details
parent (anyOf 2)nullAlternative
periodModelRequired within parentExpand Create an invoice item — response body — period
pricingJSONOptional
pricing (anyOf 1)JSONAlternativeThe pricing information of the invoice item.
pricing (anyOf 1) (anyOf 1)ModelAlternativeExpand Update an invoice's line item — response body — pricing / The pricing information of the line item / type: price details
pricing (anyOf 2)nullAlternative
prorationbooleanRequired within parentWhether the invoice item was created automatically as a proration adjustment when the customer switched plans.
proration_detailsModelOptionalExpand Create an invoice item — response body — proration details
quantityJSONRequired within parent
quantity (anyOf 1)integerAlternativeQuantity of units for the invoice item in integer format, with any decimal precision truncated. For the item's full-precision decimal quantity, use `quantity_decimal`. This field will be deprecated in favor of `quantity_decimal` in a future version. If the invoice item is a proration, the quantity of the subscription that the proration was computed for.
quantity (anyOf 2)stringAlternativePattern: ^-?[0-9]+(?:\.[0-9]+)?(?:[eE][+-]?[0-9]+)?$
quantity_decimalstringRequired within parentNon-negative decimal with at most 12 decimal places. The quantity of units for the invoice item.
Format: decimal
tax_ratesJSONOptional
tax_rates (anyOf 1)arrayAlternativeThe tax rates which apply to the invoice item. When set, the `default_tax_rates` on the invoice do not apply to this invoice item.
tax_rates (anyOf 1)[]ModelEach itemExpand Create a tax rate — response body
tax_rates (anyOf 2)nullAlternative
test_clockJSONOptional
test_clock (anyOf 1)JSONAlternativeID of the test clock this invoice item belongs to.
test_clock (anyOf 1) (anyOf 1)stringAlternativeMaximum length: 5000
test_clock (anyOf 1) (anyOf 2)ModelAlternativeExpand Create a test clock — response body
test_clock (anyOf 2)nullAlternative

Referenced models: Create an invoice item — response body — parent / The parent that generated this invoice item / type: subscription details, Update an invoice's line item — response body — pricing / The pricing information of the line item / type: price details, Create a customer — response body, Delete a customer — response body, Get Customers Customer Discount — response body, Pay an invoice — response body, Create an invoice item — response body — period, Create an invoice item — response body — invoicing rules item, Create an invoice item — response body — proration details, Create a tax rate — response body, Create a test clock — response body

Create an invoice item — request body — body period
FieldTypePresenceDescription and constraints
$objectRootThe period associated with this invoice item. When set to different values, the period will be rendered on the invoice. If you have [Stripe Revenue Recognition](https://docs.stripe.com/revenue-recognition) enabled, the period will be used to recognize and defer revenue. See the [Revenue Recognition documentation](https://docs.stripe.com/revenue-recognition/methodology/subscriptions-and-invoicing) for details.
endintegerRequired within parentFormat: unix-time
startintegerRequired within parentFormat: unix-time

SDK function policy ID: stripe.postinvoiceitems. Catalog operation: PostInvoiceitems. Rules can name either ID; function rules distinguish managed calls and conservatively cover raw calls sharing the route. Existing grant permissions and policy rules apply. wait() returns an immediate result or waits for a required approval; it never approves the request itself. Persist the approval ID to resume after a restart.

Provider errors retain their response; JSON decoding raises ProviderAPIError for provider failures. ManagedOperationError identifies contract/input/retention errors. See error handling and provider-specific behavior. Sensitive input may be refused before approval storage. A decoding error never resubmits a write.

Pinned headers: {"Stripe-Version": "2026-09-30.endive"}

Official provider source

Report an issue with this page

Necessary

Required for sign-in, security, authorization, and remembering your choices.

Always active

Analytics

Helps us understand which product and documentation features are useful.

Performance diagnostics

Uses performance tracing and privacy-masked session replay to diagnose problems.

You can change these choices at any time from Cookie settings.